#ifndef __SDUPDATER_H
#define __SDUPDATER_H

#include <Update.h>
#include "esp_partition.h"
#include "esp_ota_ops.h"

#include <WiFi.h>
#include <SD.h>

#define DEBUG_BUF_SIZE      256
#define STACK_BUF_SIZE      1024

#define FIRMWARE_PATH "/firmware/ESP32ThingPlus"

class SDUPDATER
{
	private:
		WiFiServer      *tnServer;
		WiFiClient      client;
		const char      *firm_path;
		File            bin;
		char            buf[DEBUG_BUF_SIZE];
		char            stack[STACK_BUF_SIZE];
		unsigned char   ch;
		int             getClientChar();
		boolean         status_bool;
		char            *pt;
		char            *ckpt;
		int             filenum;
		const esp_partition_t *running_partition;
		const esp_partition_t *update_partition;
		void            reboot();
		char            firmwareName[64];

	public:
		SDUPDATER();
		~SDUPDATER();
		void     begin(WiFiServer *tnserver, const char *firmware_path);
		void     print(const char* format, ...);
		void     write(char ch);
		boolean  available();
		int      read();
		void     getFirmwareName(File dir, int numTabs);
		void     update();
		void     rollback();
		uint32_t running_address();
		uint32_t update_address();
		void     restart();
};

#endif /*__SDUPDATER_H*/
