#include <WiFi.h>
#include <SPI.h>
#include "SDUpdater.h"
SDUPDATER sdupdater;
#define TELNET_PORT (23)
WiFiServer server(TELNET_PORT);
#define SDSPEED 40000000

#define SECRET_SSID "xxxxxxxxxxxx"
#define SECRET_PASS "xxxxxxxxxxxxx"

const uint8_t PRIMARY_DNS[4] = {xxx,xxx,xxx,xxx};
const uint8_t GATEWAY[4]     = {xxx,xxx,xxx,xxx};
const uint8_t SUBNETMASK[4]  = {255,255,255,0};
const uint8_t LOCAL_IP[4]    = {xxx,xxx,xxx,xxx};

// SPARKFUN ESP32 THING PLUS
#define SPI_MISO   19
#define SPI_MOSI   18
#define SPI_SCK     5
#define SPI_SD_CS   4
SPIClass SDSPI(VSPI);

void setup()
{
	if (!WiFi.config(LOCAL_IP, GATEWAY, SUBNETMASK, PRIMARY_DNS)) while(1);

	WiFi.mode(WIFI_STA);
	WiFi.begin(SECRET_SSID, SECRET_PASS); // Connect to WPA/WPA2 network
	while (1) {
		if (WiFi.status() == WL_CONNECTED) {
			server.begin();
			SDSPI.begin(SPI_SCK, SPI_MISO, SPI_MOSI, -1);
			pinMode(SPI_SD_CS, OUTPUT);
			while(!SD.begin(SPI_SD_CS, SDSPI,SDSPEED)) delay(100);
			sdupdater.begin(&server, FIRMWARE_PATH);
			break;
		}
	}

	while(!sdupdater.available());
	sdupdater.update();
}

void loop() {}
